/* strtoken.c -- an emulation for the libraries that miss it;
 * Copyright (c) 2001-2002 ForestNet IRC Network;
 * This is a free software; see file `license' for details.
 */

#include <string.h>

#ifdef NEED_strtoken
char *strtoken(char **save, char *str, char *fs)
{
	char *pos = *save;  /* keep last position across calls */
	char *tmp;

	if (str)
		pos = str; /* new string scan */

	while (pos && *pos && strchr(fs, *pos) != NULL)
		pos++; /* skip leading separators */

	if (!pos || !*pos)
		return (pos = *save = NULL); /* string contains only sep's */

	tmp = pos; /* now, keep position of the token */

	while (*pos && strchr(fs, *pos) == NULL)
		pos++; /* skip content of the token */

	if (*pos)
		*pos++ = '\0'; /* remove first sep after the token */
	else
		pos = NULL; /* end of string */

	*save = pos;
	return (tmp);
}
#endif
